#!/bin/sh

#ipaddr_conf     - статический IP
#netmask         - сетевая маска
#gatewayip       - GateWay (шлюз)
#dnsip           - DNS
#ntpurl          - NTP url
#mcip_conf       - bootstrap IP
#mcport_conf     - bootstrap Port
#mcip_img_conf   - image IP
#mcip_port_conf  - image Port
#portal1      - url портала 1
#portal2      - url портала 2
#volume       - громкость (int)
#language     - индекс языка (int)

#    . /etc/stb_params
PORTAL_1=`fw_printenv portal1 2>/dev/null`
PORTAL_1=${PORTAL_1#portal1=}

PORTAL_2=`fw_printenv portal2 2>/dev/null`
PORTAL_2=${PORTAL_2#portal2=}

PORTAL_TMP=`cat /ram/dhcp_ready | grep "portal_dhcp="`
PORTAL_TMP=${PORTAL_TMP%%#*}
PORTAL_TMP=${PORTAL_TMP#portal_dhcp=}

USE_PORTAL_DHCP=`fw_printenv use_portal_dhcp 2>/dev/null`
USE_PORTAL_DHCP=${USE_PORTAL_DHCP#use_portal_dhcp=}

if [ -z "$USE_PORTAL_DHCP" ]; then
    fw_setenv use_portal_dhcp true 
    USE_PORTAL_DHCP=true
fi

if [ "$USE_PORTAL_DHCP" != "true" ]; then
    PORTAL_DHCP=
else
    PORTAL_DHCP=`fw_printenv portal_dhcp 2>/dev/null`
    PORTAL_DHCP=${PORTAL_DHCP#portal_dhcp=}
    if [ "$PORTAL_DHCP" != "$PORTAL_TMP" ]; then
	fw_setenv portal_dhcp $PORTAL_TMP
	PORTAL_DHCP=$PORTAL_TMP
    fi
fi

upd_sboot=`cat /ram/dhcp_ready | grep "upd_sboot="`
upd_sboot=${upd_sboot%%#*}
upd_sboot=${upd_sboot#upd_sboot=}

upd_sb_ver=`cat /ram/dhcp_ready | grep "upd_sb_ver="`
upd_sb_ver=${upd_sb_ver%%#*}
upd_sb_ver=${upd_sb_ver#upd_sb_ver=}

if [ -n "$upd_sboot" ]; then
   /usr/bin/update_second_boot.sh $upd_sboot $upd_sb_ver
fi

upd_ver=`cat /ram/dhcp_ready | grep "upd_ver="`
upd_ver=${upd_ver%%#*}
upd_ver=${upd_ver#upd_ver=}

upd_url=`cat /ram/dhcp_ready | grep "upd_url="`
upd_url=${upd_url%%#*}
upd_url=${upd_url#upd_url=}

upd_mode=`cat /ram/dhcp_ready | grep "upd_mode="`
upd_mode=${upd_mode%%#*}
upd_mode=${upd_mode#upd_mode=}

if [ -n "$upd_ver" ]; then
    echo "The update number version: $upd_ver"
    img_version_now=`fw_printenv Image_Version 2>/dev/null`
    img_version_now=${img_version_now#Image_Version=}
    if [ "$upd_ver" -eq "$img_version_now" ]; then
        echo "The number version's equal"
    else
        # We need update
        /usr/bin/update_img.sh $upd_ver $upd_url $upd_mode
    fi
fi

if [ "$PORTAL_1$PORTAL_2$PORTAL_DHCP" ]; then
    echo "Loading start page..."
    /usr/share/qt-4.6.0/stbapp -qws -display directfb file:///home/web/index.html
else
    echo "Error loading portal. Service Page"
    /usr/share/qt-4.6.0/stbapp -qws -display directfb /home/web/services.html
fi
