#  WLAN 
#  <SSID>::<AUTH method>::<Cipher>::<Authentication Suit>::<rfInfo>

BEGIN {
   true = 1;
   false = 0;
   isSection = false;
   isWpa1Valid = false;
   isWpa1Present = false;
   isWpa1SubIdx = 0;
   wpa1Enc = "NONE";
   wpa1Auth = "NONE";
   isWpa2Valid = false;
   isWpa2Present = false;
   isWpa2SubIdx = 0;
   isWepPresent = false;
   wpa2Enc = "NONE";
   wpa2Auth = "NONE";
   k = 0;
   contextLineNumber = 0;
   isSectionOpened = false;
   ssID = "";
   rfInfo = "";
   signalInfo = "";
}

function printArr(a)
{
   printf("Array data: ");
   for (v in a)
     printf("[%d]='%s',", v);

   printf("\n");
}

function initSection()
{
   contextLineNumber = 0;
   ssID = "";
   rfInfo = "";
   isWpa1Valid = false;
   isWpa1Present = false;
   isWpa1SubIdx = 0;
   wpa1Enc = "NONE";
   wpa1Auth = "NONE";
   isWpa2Valid = false;
   isWpa2Present = false;
   isWpa2SubIdx = 0;
   isWepPresent = false;
   wpa2Enc = "NONE";
   wpa2Auth = "NONE";
}
function closeSection()
{
   if(isWpa2Valid){
      printf("%s::WPA2::%s::%s::%s::%s\n", ssID, wpa2Enc, wpa2Auth, signalInfo, rfInfo);
      return;
   }
   if(isWpa1Valid){
      printf("%s::WPA::%s::%s::%s::%s\n", ssID, wpa1Enc, wpa1Auth, signalInfo, rfInfo);
      return;
   }
   if(isWepPresent){
      printf("%s::WEPAUTO::%s::%s::%s::%s\n", ssID, "WEP", wpa1Auth, signalInfo, rfInfo);
      return;
   }
   printf("%s::NONE::%s::%s::%s::%s\n", ssID, "NONE", "NONE", signalInfo, rfInfo);
}
function checkWep()
{
  if($0 == "                    Encryption key:on"){
     isWepPresent = true;
    return;
  }
  if($0 == "                    Encryption key:off"){
     isWepPresent = false;
    return;
  }
}

function checkWpa1()
{
   if(isWpa1Present == false) {
#     printf("cp1. s = '%s'\n", $0);
      if($0 == "                    IE: WPA Version 1"){
         isWpa1Present = true;
         isWpa1SubIdx = 0;
      }
      return;
   }

   isWpa1SubIdx++;

   if(isWpa1SubIdx == 2){
      if(index($0, " TKIP") > 0){
         wpa1Enc = "TKIP"
         return;
      }
      if(index($0, " CCMP") > 0){
         wpa1Enc = "CCMP"
         return;
      }
   }

   if(isWpa1SubIdx == 3){
      if(index($0, " PSK") > 0){
         wpa1Auth = "PSK"
            if(wpa1Enc != "NONE"){
               isWpa1Valid = true;
            }
         return;
      }
   }
}
function checkWpa2()
{
   if(isWpa2Present == false) {
#     printf("cp1. s = '%s'\n", $0);
      if($0 == "                    IE: IEEE 802.11i/WPA2 Version 1"){
         isWpa2Present = true;
         isWpa2SubIdx = 0;
      }
      return;
   }

   isWpa2SubIdx++;

   if(isWpa2SubIdx == 2){
      if(index($0, " TKIP") > 0){
         wpa2Enc = "TKIP"
         return;
      }
      if(index($0, " CCMP") > 0){
         wpa2Enc = "CCMP"
         return;
      }
   }

   if(isWpa2SubIdx == 3){
      if(index($0, " PSK") > 0){
         wpa2Auth = "PSK"
            if(wpa2Enc != "NONE"){
               isWpa2Valid = true;
            }
         return;
      }
   }
}
function checkSSID()
{
  tmpIndex = index($0, "ESSID:");
  if(tmpIndex > 0) {
     tmpIndex = index($0, ":");
     tmpStr = substr($0, tmpIndex + 1);
     ssID = tmpStr;
  }
}
function checkChannel()
{
  if(contextLineNumber == 3) {
     tmpIndex = index($0, "Frequency:");
     if(tmpIndex > 0) {
        rfInfo = substr($0, tmpIndex);
     }
  }
  if(contextLineNumber == 4) {
    stringToFind = "Signal level=";
     tmpIndex = index($0, stringToFind);
     if(tmpIndex > 0) {
	tmpIndex += length(stringToFind);
	tmpStr = substr($0, tmpIndex);
	tmpIndex2 = index(tmpStr, " dBm");
	if(tmpIndex2 > 0) {
    	    signalInfo = substr(tmpStr, 1, tmpIndex2 - 1);
	}
     }
  }
}
function checkNextSection(isEOF)
{
   if($1 == "Cell" || isEOF == true) {
      if(isSectionOpened == true) {
         closeSection();
      }
      initSection();
      isSectionOpened = true;
      return;
   }

   contextLineNumber++;

   if($1 == "Cell" && cell == true) {
      printf("End Cell:%d\n",k-1);
   }
}

{
   k++;
#  printf("cell = %d\n", cell);

#  printf("$1 = '%s'\n", $0);

   checkSSID();
   checkChannel();
   checkWpa1();
   checkWpa2();
   checkWep();

   checkNextSection(false);

#  if($1 == "Cell") {
#     cell = true;
#     printf("Start Cell:%d - ",k);
#  }
}

END {
   checkNextSection(true);
#  if(cell) {
#     printf("End Cell:%d\n",k-1)
#  }
}

